import os
import sys
import fileinput

scriptDir = os.path.dirname (sys.argv[0])
file = os.path.join (scriptDir, "Bunny.obj")

if os.path.isfile (file) is False:
	sys.exit ("File does not exists: {}".format (file))

def CreateMorphFromOBJFile (filePath, scale):
	materials = GetAttributeDictionary (API_MaterialID)

	material = APIObject ()
	material.attributeIndex = list (materials)[0]
	material.overridden = True

	body = ModelerBody ()
	body.Create ()

	vertices = []
	polygons = []

	fileinput.close ()
	for line in fileinput.input (filePath):
		if line[0] == "#": 
			continue

		line = line.strip ()
		while "  " in line: 
			line = line.replace ("  ", " ")
		parts = line.split (" ")

		if (parts[0] == "v"):
			vertices.append (body.AddVertex (scale * float (parts[1]),
											 scale * float (parts[3]),
											 scale * float (parts[2])))

		if (parts[0] == "f"):
			v = []
			e = []

			for i in range (1, len (parts)):
				subparts = parts[i].split ("/")
				v.append (int (subparts[0]) - 1)

			last = len (v) - 1
			for i in range (0, last):
				e.append (body.AddEdge (v[i], v[i + 1]))
			e.append (body.AddEdge (v[last], v[0]))
			polygons.append (body.AddPolygon (e, 0, material))

	fileinput.close ()
	body.Finish ()

	pens = GetAttributeDictionary (API_PenID)

	morphPars = APIObject ()
	morphPars.edgeType = APIMorphEdgeType_SoftHiddenEdge
	morphPars.castShadow = False
	morphPars.receiveShadow = False
	morphPars.coverFillPen = list (pens)[0]
	morphPars.uncutLinePen = list (pens)[1]
	morphPars.cutLinePen = list (pens)[2]
	morphPars.useDistortedCoverFill = False
	morphMemo = APIObject ()
	morphMemo.morphBody = body
	del body
	return CreateMorph (morphPars, morphMemo)

CreateMorphFromOBJFile (file, 100)
