materials = GetAttributeDictionary (API_MaterialID)

material1 = APIObject ()
material1.attributeIndex = list (materials)[0]
material1.overridden = True

material2 = APIObject ()
material2.attributeIndex = list (materials)[1]
material2.overridden = True

w = 2

with UndoScope ("Draw Chessboard"):
	for x in range (8):
		for y in range (8):
			body = ModelerBody ()
			body.Create ()

			v1 = body.AddVertex (x * w,   	y * w, 	    0)
			v2 = body.AddVertex (w + x * w, y * w, 	    0)
			v3 = body.AddVertex (w + x * w, w + y * w,  0)
			v4 = body.AddVertex (x * w,   	w + y * w,  0)

			e1 = body.AddEdge (v1, v2)
			e2 = body.AddEdge (v2, v3)
			e3 = body.AddEdge (v3, v4)
			e4 = body.AddEdge (v4, v1)

			n1 = body.AddNormal (0, 0, 1)

			if (x + y) % 2 == 1:
				f1 = body.AddPolygon ([e1, e2, e3, e4], n1, material1)
			else:
				f1 = body.AddPolygon ([e1, e2, e3, e4], n1, material2)

			body.Finish ()

			morphPars = APIObject ()
			morphMemo = APIObject ()
			morphMemo.morphBody = body

			CreateMorph (morphPars, morphMemo)
