import os
import sys
import xlsxwriter

scriptDir = os.path.dirname (sys.argv[0])
outputFile = os.path.join (scriptDir, "Test.xlsx")

def ExportPropertiesToExcel (elemGuid, fileName):
	workbook = xlsxwriter.Workbook (fileName)
	worksheet = workbook.add_worksheet ("Properties")
	definitionDictionary = GetElementPropertyDefinitionDictionary (elemGuid, API_PropertyDefinitionFilter_All)

	headlineFormat = {'bold': True, 'bottom': True, 'align': 'center'}
	headline = workbook.add_format (headlineFormat)

	worksheet.set_column ('A:B', 55)
	worksheet.set_column ('C:C', 10)

	worksheet.write (0, 0, "PROPERTY", headline)
	worksheet.write (0, 1, "VALUE", headline)
	worksheet.write (0, 2, "DEFAULT", headline)

	worksheet.write (1, 0, "Element GUID")
	worksheet.write (1, 1, elemGuid)
	worksheet.write (1, 2, False)

	row = 2
	for d in definitionDictionary.values ():
		property = GetElementProperty (elemGuid, d.guid)
		value = property.value
		if isinstance (value, list):
			value = repr (value)

		worksheet.write (row, 0, d.name)
		worksheet.write (row, 1, value)
		worksheet.write (row, 2, property.isDefault)
		if property.definition.collectionType == API_PropertySingleChoiceEnumerationCollectionType:
			valList = []
			for en in property.definition.possibleEnumValues:
				valList.append (en)
			worksheet.data_validation (row, 1, row, 1,
									   {'validate': 'list',
										'source': valList})

		row += 1

	workbook.close ()

ExportPropertiesToExcel (ClickElement (), outputFile)
